package baza2;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import javax.swing.*;
import java.util.*;

class Osoba 
 { String nazwisko;
   float srednia;
   String uwagi;
    
   public  void Nadaj_nazwisko(String lan)
    { nazwisko=lan;}
   public String Podaj_nazwisko()
    { return nazwisko;}
   public  void Nadaj_uwagi(String lan)
    { uwagi=lan;}
   public String Podaj_uwagi()
     { return uwagi;}
   public  void Nadaj_srednia(float srednia_)
    { srednia=srednia_;} 
  public float Podaj_srednia()
     {return srednia;}

  public String toString()
   {String napis="";
    napis+="Nazwisko: "+nazwisko;
    napis+=" srednia: "+srednia;
    napis+=" uwagi: "+uwagi;
    return napis;
   }
   
  public boolean Szukaj(String s) 
   { return nazwisko.equals(s);
   }
  
  public byte[] Zamien_na_bajty()
   { byte pom[];
     String S,S1;
     S1=Float.toString(srednia);
     S=" "+" "+" "+nazwisko+S1+uwagi;
     pom=S.getBytes();
     pom[0]=(byte)nazwisko.length();   
     pom[1]=(byte)S1.length(); 
     pom[2]=(byte)uwagi.length();
     return pom;
   }
 }  

class  Tablica
{    
  Osoba Dane[]=null; 
  int ile=0;  
  
  public boolean Pusta()
    {
      return ile==0;
    }
  
  public boolean Pelna()
    {
      return ile==Dane.length;
    }
 public int Podaj_ile()
   {
     return ile;
   }
 
  public void Wykonaj_tablice(int N)
   {
      ile=0;
      Dane=new Osoba[N]; //utworzenie tablicy
   }
  
  public void Wstaw (String nazwisko_, float srednia, String uwagi_)
   {
      Osoba dana=new Osoba();
      dana.Nadaj_nazwisko(nazwisko_);
      dana.Nadaj_srednia(srednia);
      dana.Nadaj_uwagi(uwagi_);
      Dane[ile]=dana;
      ile++; 
   }
  
   public Osoba Wyszukaj(String s)
    {
      for (int i=0; i<ile;i++)
       if (Dane[i].Szukaj(s))
        return   Dane[i];
      return null;
    }
   
   public String toString()
   {
       String s="";
       for (int i=0; i<ile; i++)
         s+=Dane[i].toString()+"\n";
       return s;
   }
}

public class Baza2
{ 
  protected Tablica tablica=new Tablica();
  
  public void Wyswietl()
     {
      if (tablica.Pusta())//jesli tablica istnieje, to mozna wyswietlac
           JOptionPane.showMessageDialog(null,"Brak danych"); 
      else 
        JOptionPane.showMessageDialog(null,tablica.toString()); 
    }
  
  public void Wypelnij()
    { String S;
      S=JOptionPane.showInputDialog(null,"Podaj rozmiar tablicy");
      int N=Integer.parseInt(S);
      tablica.Wykonaj_tablice(N); //utworzenie tablicy
      String S1,S2,S3;
      while(!tablica.Pelna()) //jeśli tablica jes zapełniona, tak jest równe false
       { 
         S1 = JOptionPane.showInputDialog(null, "Podaj nazwisko"); 
         S2 = JOptionPane.showInputDialog(null, "Podaj srednia");
         S3 =JOptionPane.showInputDialog(null, "Podaj uwagi");
         tablica.Wstaw(S1, Float.parseFloat(S2), S3);//dopisanie danych na końcu danych
       }  
    }
 
   public void Wyszukaj()
   {
     if (tablica.Pusta())//jesli tablica istnieje, to mozna wyszukac
           JOptionPane.showMessageDialog(null,"Brak danych"); 
     else
     {
      String S = JOptionPane.showInputDialog(null,"Podaj nazwisko");
      Object osoba=tablica.Wyszukaj(S);   
      if(osoba!=null)
       JOptionPane.showMessageDialog(null,osoba.toString()); 
     }
   }
   
   public void Zapisz_do_pliku_binarnego()
   {  byte pom[];
      if (tablica.Pusta())//jesli tablica istnieje, to mozna zapisac do pliku
           JOptionPane.showMessageDialog(null,"Brak danych"); 
      else 
      try
       { FileOutputStream plik = new FileOutputStream ("baza2.dat");
      	 BufferedOutputStream bufor = new BufferedOutputStream (plik);
         bufor.write(tablica.ile); 
         for (int i=0; i<tablica.ile;i++)
         {  
           pom=tablica.Dane[i].Zamien_na_bajty();
           bufor.write(pom);      
         }   
         bufor.close();
        } catch (IOException e)
           { JOptionPane.showMessageDialog(null,
                 "Blad zapisu pliku binarnego" +e); 
           } 
   }  
   
   public void Odczytaj_plik_binarny_na_ekran()
    { byte pom1[],pom2[],pom3[];
      String S="",S1;
      int rozmiar;
         try
          {  FileInputStream plik = new FileInputStream ("baza2.dat");
      	     BufferedInputStream bufor = new BufferedInputStream (plik);         	         	         
             rozmiar=bufor.read();
             rozmiar=bufor.read();
             while(rozmiar!=-1)
               { 
                 pom1=new byte[rozmiar];
                 rozmiar=bufor.read();
                 pom2=new byte[rozmiar];
                 rozmiar=bufor.read();
                 pom3=new byte[rozmiar];
                 bufor.read(pom1,0,pom1.length);           
                 bufor.read(pom2,0,pom2.length);
                 bufor.read(pom3,0,pom3.length);       
                 S1=new String(pom1);
                 S+=S1+" ";
                 S1=new String(pom2);
                 S+=S1+" ";
                 S1=new String(pom3);
                 S+=S1+"\n"; 
                 rozmiar=bufor.read();
               }
             bufor.close();
             JOptionPane.showMessageDialog(null,S);
            } catch (IOException e)
                { JOptionPane.showMessageDialog(null,
                   "Blad odczytu pliku binarnego "+e);
                }
    }
    
    public void Odczytaj_plik_binarny_do_tablicy()
    { byte pom1[],pom2[],pom3[];
      String S1,S2,S3;
      int rozmiar;
         try
          {      
             FileInputStream plik = new FileInputStream ("baza2.dat");
      	     BufferedInputStream bufor = new BufferedInputStream (plik);         	         	                   
             rozmiar=bufor.read();
             tablica.Wykonaj_tablice(rozmiar);
             rozmiar=bufor.read();
             while(rozmiar!=-1)
               { 
                 pom1=new byte[rozmiar];
                 rozmiar=bufor.read();
                 pom2=new byte[rozmiar];
                 rozmiar=bufor.read();
                 pom3=new byte[rozmiar];
                 bufor.read(pom1,0,pom1.length);           
                 bufor.read(pom2,0,pom2.length);
                 bufor.read(pom3,0,pom3.length);       
                 S1=new String(pom1);  
                 S2=new String(pom2);
                 S3=new String(pom3); 
                 tablica.Wstaw(S1,Float.parseFloat(S2),S3);
                 rozmiar=bufor.read();
               }
             bufor.close();
             } catch (IOException e)
                { JOptionPane.showMessageDialog(null,
                   "Blad odczytu pliku binarnego "+e);
                }
    }
   
   static public  void main(String args[])
   {  Baza2 baza1=new Baza2(); //referencja do tablicy, ktora jest tworzona w opcji 1
      char ch;
      String s;
      do
      { s=JOptionPane.showInputDialog(null, "Progam nie jest zabezpieczony przed\n" +
                "złym formatem danych\n i naciskaniem Cancel w okienkach dialogowych\n"+
                "Podaj wybor"
        +"\n1 - Wypelnij tablice,"
        +"\n2 - Wyswietl dane osob"
        +"\n3 - Wyszukaj osobe i wyswietl jej dane"
        +"\n4 - Zapisz plik w formacie binarnym"
        +"\n5 - Odczytaj plik w formacie binarnym i wyswietl na ekranie"
        +"\n6 - Odczytaj plik w formacie binarnym i zapisz do tablicy"
        +"\nk - Koniec programu");
      ch = s.charAt(0);  //pobranie opcji
      switch(ch)
       {case '1' : baza1.Wypelnij();
                   break;
        case '2' : baza1.Wyswietl();        
                   break;
        case '3' : baza1.Wyszukaj(); 
                   break;  
        case '4' : baza1.Zapisz_do_pliku_binarnego();
                   break;
        case '5' : baza1.Odczytaj_plik_binarny_na_ekran();
                   break;
        case '6' : baza1.Odczytaj_plik_binarny_do_tablicy();
                   break;
        case 'k' : JOptionPane.showMessageDialog(null, "Koniec programu");
                   break;
        default  : JOptionPane.showMessageDialog(null,"Zla opcja");       
    }
 }while (ch != 'k') ;
 System.exit(0); 
  }
}

